stages:
  - test
  - build

# -------------------- #
# BUILD
# -------------------- #
build:user-service:nest:
  stage: build
  extends: .cache:node_modules
  cache:
    policy: pull
  needs:
    - prepare:install_node_modules
  script:
    - npm run -w=@app/user-service prisma:generate
    - npm run build:user-service
  artifacts:
    paths:
      - dist/apps/user-service
      - apps/user-service/prisma/generated
    expire_in: 1 day
  interruptible: true

build:user-service:dot-env:
  stage: build
  rules:
    - if: $USER_SERVICE_TEST_ENV
  script:
    - cp $USER_SERVICE_TEST_ENV apps/user-service/.env.test
  artifacts:
    paths:
      - apps/user-service/.env.test
    expire_in: 1 day
  interruptible: true

# -------------------- #
# TEST
# -------------------- #
test:user-service:unit:
  extends: .cache:node_modules
  stage: test
  needs:
    - job: build:user-service:nest
      artifacts: true
    - job: build:user-service:dot-env
      artifacts: true
  script:
    - npm run -w=@app/user-service test:unit:ci
  artifacts:
    paths:
      - coverage/app/user-service/unit
    expire_in: 1 hour
    reports:
      junit: apps/user-service/junit.xml
  interruptible: true

test:user-service:e2e:
  extends: .cache:node_modules
  stage: test
  needs:
    - job: build:user-service:nest
      artifacts: true
    - job: build:user-service:dot-env
      artifacts: true
  services:
    - name: nats:2.10
      alias: nats
  script:
    - npm run -w=@app/user-service test:e2e:ci
  artifacts:
    paths:
      - coverage/app/user-service/e2e
    expire_in: 1 hour
  interruptible: true
